<html>
<head>
<title>OGRE: Ogre::RadixSort&lt; TContainer, TContainerValueType, TCompValueType &gt; Class Template Reference - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.5.3 -->
<div class="tabs">
  <ul>
    <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
    <li><a href="namespaces.html"><span>Namespaces</span></a></li>
    <li class="current"><a href="classes.html"><span>Classes</span></a></li>
    <li><a href="files.html"><span>Files</span></a></li>
    <li><a href="dirs.html"><span>Directories</span></a></li>
    <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
  </ul>
</div>
<div class="tabs">
  <ul>
    <li><a href="classes.html"><span>Alphabetical&nbsp;List</span></a></li>
    <li><a href="annotated.html"><span>Class&nbsp;List</span></a></li>
    <li><a href="hierarchy.html"><span>Class&nbsp;Hierarchy</span></a></li>
    <li><a href="functions.html"><span>Class&nbsp;Members</span></a></li>
  </ul>
</div>
<div class="nav">
<a class="el" href="namespaceOgre.html">Ogre</a>::<a class="el" href="classOgre_1_1RadixSort.html">RadixSort</a></div>
<h1>Ogre::RadixSort&lt; TContainer, TContainerValueType, TCompValueType &gt; Class Template Reference</h1><!-- doxytag: class="Ogre::RadixSort" -->Class for performing a radix sort (fast comparison-less sort based on byte value) on various standard STL containers.  
<a href="#_details">More...</a>
<p>
<code>#include &lt;<a class="el" href="OgreRadixSort_8h-source.html">OgreRadixSort.h</a>&gt;</code>
<p>

<p>
<a href="classOgre_1_1RadixSort-members.html">List of all members.</a><table border="0" cellpadding="0" cellspacing="0">
<tr><td></td></tr>
<tr><td colspan="2"><br><h2>Public Types</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">typedef <br>
TContainer::iterator&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RadixSort.html#e6832006de9925d59d8795d4f708f08f">ContainerIter</a></td></tr>

<tr><td colspan="2"><br><h2>Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RadixSort.html#2c982200600a22b21906e3f43a0a962d">RadixSort</a> ()</td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RadixSort.html#8f49cae4360e7c83b6ca7cf5714db761">~RadixSort</a> ()</td></tr>

<tr><td class="memTemplParams" nowrap colspan="2">template&lt;class TFunction&gt; </td></tr>
<tr><td class="memTemplItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="classOgre_1_1RadixSort.html#b3a589546b32250272870bd0cd471116">sort</a> (TContainer &amp;container, TFunction func)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Main sort function.  <a href="#b3a589546b32250272870bd0cd471116"></a><br></td></tr>
<tr><td colspan="2"><br><h2>Protected Member Functions</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RadixSort.html#214c198ead344cf63ea82336b5e63f54">sortPass</a> (int byteIndex)</td></tr>

<tr><td class="memTemplParams" nowrap colspan="2">template&lt;typename T&gt; </td></tr>
<tr><td class="memTemplItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="classOgre_1_1RadixSort.html#024faae2b21a9417983dce5c8167e61f">finalPass</a> (int byteIndex, T val)</td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RadixSort.html#9d5c1b55a50cded48d3ccbe38182766e">finalPass</a> (int byteIndex, int val)</td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RadixSort.html#985875ef2e1f317eea143cac7b7dc529">finalPass</a> (int byteIndex, float val)</td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">unsigned char&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RadixSort.html#c54a7d0ddf8b1f42f4d33dc0b9aec0cd">getByte</a> (int byteIndex, TCompValueType val)</td></tr>

<tr><td colspan="2"><br><h2>Protected Attributes</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RadixSort.html#c6718da2036c0980c508536bbdf64668">mCounters</a> [4][256]</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Alpha-pass counters of values (histogram) 4 of them so we can radix sort a maximum of a 32bit value.  <a href="#c6718da2036c0980c508536bbdf64668"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RadixSort.html#0d46f30b03aedeb510dec893bee18e64">mOffsets</a> [256]</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Beta-pass offsets.  <a href="#0d46f30b03aedeb510dec893bee18e64"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RadixSort.html#9c004d058dec49d422482103af7a06dd">mSortSize</a></td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Sort area size.  <a href="#9c004d058dec49d422482103af7a06dd"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RadixSort.html#02ac6146623e353cd5c36ffa4eb30373">mNumPasses</a></td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Number of passes for this type.  <a href="#02ac6146623e353cd5c36ffa4eb30373"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">std::vector&lt; <a class="el" href="structOgre_1_1RadixSort_1_1SortEntry.html">SortEntry</a> &gt;&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RadixSort.html#2112b0f31c640327366def3806dcab5d">mSortArea1</a></td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Temp sort storage.  <a href="#2112b0f31c640327366def3806dcab5d"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">std::vector&lt; <a class="el" href="structOgre_1_1RadixSort_1_1SortEntry.html">SortEntry</a> &gt;&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RadixSort.html#d3a26ac464f5b59d75286e9b12cd2994">mSortArea2</a></td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">std::vector<br>
&lt; <a class="el" href="structOgre_1_1RadixSort_1_1SortEntry.html">SortEntry</a> &gt; *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RadixSort.html#a22e981b5a53295efd161b192d636dcb">mSrc</a></td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">std::vector<br>
&lt; <a class="el" href="structOgre_1_1RadixSort_1_1SortEntry.html">SortEntry</a> &gt; *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RadixSort.html#aeca7c2e0fe32e56d2e373b25d41a329">mDest</a></td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">TContainer&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RadixSort.html#98e68e712c66b7d02426d76382b4bff4">mTmpContainer</a></td></tr>

<tr><td colspan="2"><br><h2>Classes</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">struct &nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structOgre_1_1RadixSort_1_1SortEntry.html">SortEntry</a></td></tr>

</table>
<hr><a name="_details"></a><h2>Detailed Description</h2>
<h3>template&lt;class TContainer, class TContainerValueType, typename TCompValueType&gt;<br>
 class Ogre::RadixSort&lt; TContainer, TContainerValueType, TCompValueType &gt;</h3>

Class for performing a radix sort (fast comparison-less sort based on byte value) on various standard STL containers. 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>A radix sort is a very fast sort algorithm. It doesn't use comparisons and thus is able to break the theoretical minimum O(N*logN) complexity. Radix sort is complexity O(k*N), where k is a constant. Note that radix sorting is not in-place, it requires additional storage, so it trades memory for speed. The overhead of copying means that it is only faster for fairly large datasets, so you are advised to only use it for collections of at least a few hundred items. </dd></dl>
<dl class="user" compact><dt><b></b></dt><dd>This is a template class to allow it to deal with a variety of containers, and a variety of value types to sort on. In addition to providing the container and value type on construction, you also need to supply a functor object which will retrieve the value to compare on for each item in the list. For example, if you had an std::vector of by-value instances of an object of class 'Bibble', and you wanted to sort on Bibble::getDoobrie(), you'd have to firstly create a functor like this: <div class="fragment"><pre class="fragment">        <span class="keyword">struct </span>BibbleSortFunctor
        {
            <span class="keywordtype">float</span> operator()(<span class="keyword">const</span> Bibble&amp; val)<span class="keyword"> const</span>
<span class="keyword">            </span>{
                <span class="keywordflow">return</span> val.getDoobrie();
            }
        }
</pre></div> Then, you need to declare a <a class="el" href="classOgre_1_1RadixSort.html" title="Class for performing a radix sort (fast comparison-less sort based on byte value)...">RadixSort</a> class which names the container type, the value type in the container, and the type of the value you want to sort by. You can then call the sort function. E.g. <div class="fragment"><pre class="fragment">        RadixSort&lt;BibbleList, Bibble, float&gt; radixSorter;
        BibbleSortFunctor functor;

        radixSorter.sort(myBibbleList, functor);
</pre></div> You should try to reuse <a class="el" href="classOgre_1_1RadixSort.html" title="Class for performing a radix sort (fast comparison-less sort based on byte value)...">RadixSort</a> instances, since repeated allocation of the internal storage is then avoided. </dd></dl>
<dl class="note" compact><dt><b>Note:</b></dt><dd>Radix sorting is often associated with just unsigned integer values. Our implementation can handle both unsigned and signed integers, as well as floats (which are often not supported by other radix sorters). doubles are not supported; you will need to implement your functor object to convert to float if you wish to use this sort routine. </dd></dl>

<p>Definition at line <a class="el" href="OgreRadixSort_8h-source.html#l00083">83</a> of file <a class="el" href="OgreRadixSort_8h-source.html">OgreRadixSort.h</a>.</p>
<hr><h2>Member Typedef Documentation</h2>
<a class="anchor" name="e6832006de9925d59d8795d4f708f08f"></a><!-- doxytag: member="Ogre::RadixSort::ContainerIter" ref="e6832006de9925d59d8795d4f708f08f" args="" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class TContainer, class TContainerValueType, typename TCompValueType&gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">typedef TContainer::iterator <a class="el" href="classOgre_1_1RadixSort.html">Ogre::RadixSort</a>&lt; TContainer, TContainerValueType, TCompValueType &gt;::<a class="el" href="classOgre_1_1RadixSort.html#e6832006de9925d59d8795d4f708f08f">ContainerIter</a>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgreRadixSort_8h-source.html#l00086">86</a> of file <a class="el" href="OgreRadixSort_8h-source.html">OgreRadixSort.h</a>.</p>

</div>
</div><p>
<hr><h2>Constructor &amp; Destructor Documentation</h2>
<a class="anchor" name="2c982200600a22b21906e3f43a0a962d"></a><!-- doxytag: member="Ogre::RadixSort::RadixSort" ref="2c982200600a22b21906e3f43a0a962d" args="()" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class TContainer, class TContainerValueType, typename TCompValueType&gt; </div>
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1RadixSort.html">Ogre::RadixSort</a>&lt; TContainer, TContainerValueType, TCompValueType &gt;::<a class="el" href="classOgre_1_1RadixSort.html">RadixSort</a>           </td>
          <td>(</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgreRadixSort_8h-source.html#l00231">231</a> of file <a class="el" href="OgreRadixSort_8h-source.html">OgreRadixSort.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="8f49cae4360e7c83b6ca7cf5714db761"></a><!-- doxytag: member="Ogre::RadixSort::~RadixSort" ref="8f49cae4360e7c83b6ca7cf5714db761" args="()" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class TContainer, class TContainerValueType, typename TCompValueType&gt; </div>
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1RadixSort.html">Ogre::RadixSort</a>&lt; TContainer, TContainerValueType, TCompValueType &gt;::~<a class="el" href="classOgre_1_1RadixSort.html">RadixSort</a>           </td>
          <td>(</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgreRadixSort_8h-source.html#l00232">232</a> of file <a class="el" href="OgreRadixSort_8h-source.html">OgreRadixSort.h</a>.</p>

</div>
</div><p>
<hr><h2>Member Function Documentation</h2>
<a class="anchor" name="214c198ead344cf63ea82336b5e63f54"></a><!-- doxytag: member="Ogre::RadixSort::sortPass" ref="214c198ead344cf63ea82336b5e63f54" args="(int byteIndex)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class TContainer, class TContainerValueType, typename TCompValueType&gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1RadixSort.html">Ogre::RadixSort</a>&lt; TContainer, TContainerValueType, TCompValueType &gt;::sortPass           </td>
          <td>(</td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>byteIndex</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgreRadixSort_8h-source.html#l00115">115</a> of file <a class="el" href="OgreRadixSort_8h-source.html">OgreRadixSort.h</a>.</p>

<p>Referenced by <a class="el" href="OgreRadixSort_8h-source.html#l00134">Ogre::RadixSort&lt; std::vector&lt; RenderablePass &gt;, Ogre::RenderablePass, float &gt;::finalPass()</a>, and <a class="el" href="OgreRadixSort_8h-source.html#l00240">Ogre::RadixSort&lt; std::vector&lt; RenderablePass &gt;, Ogre::RenderablePass, float &gt;::sort()</a>.</p>

</div>
</div><p>
<a class="anchor" name="024faae2b21a9417983dce5c8167e61f"></a><!-- doxytag: member="Ogre::RadixSort::finalPass" ref="024faae2b21a9417983dce5c8167e61f" args="(int byteIndex, T val)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class TContainer, class TContainerValueType, typename TCompValueType&gt; </div>
<div class="memtemplate">
template&lt;typename T&gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1RadixSort.html">Ogre::RadixSort</a>&lt; TContainer, TContainerValueType, TCompValueType &gt;::finalPass           </td>
          <td>(</td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>byteIndex</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">T&nbsp;</td>
          <td class="paramname"> <em>val</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgreRadixSort_8h-source.html#l00134">134</a> of file <a class="el" href="OgreRadixSort_8h-source.html">OgreRadixSort.h</a>.</p>

<p>Referenced by <a class="el" href="OgreRadixSort_8h-source.html#l00240">Ogre::RadixSort&lt; std::vector&lt; RenderablePass &gt;, Ogre::RenderablePass, float &gt;::sort()</a>.</p>

</div>
</div><p>
<a class="anchor" name="9d5c1b55a50cded48d3ccbe38182766e"></a><!-- doxytag: member="Ogre::RadixSort::finalPass" ref="9d5c1b55a50cded48d3ccbe38182766e" args="(int byteIndex, int val)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class TContainer, class TContainerValueType, typename TCompValueType&gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1RadixSort.html">Ogre::RadixSort</a>&lt; TContainer, TContainerValueType, TCompValueType &gt;::finalPass           </td>
          <td>(</td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>byteIndex</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>val</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgreRadixSort_8h-source.html#l00141">141</a> of file <a class="el" href="OgreRadixSort_8h-source.html">OgreRadixSort.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="985875ef2e1f317eea143cac7b7dc529"></a><!-- doxytag: member="Ogre::RadixSort::finalPass" ref="985875ef2e1f317eea143cac7b7dc529" args="(int byteIndex, float val)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class TContainer, class TContainerValueType, typename TCompValueType&gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1RadixSort.html">Ogre::RadixSort</a>&lt; TContainer, TContainerValueType, TCompValueType &gt;::finalPass           </td>
          <td>(</td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>byteIndex</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">float&nbsp;</td>
          <td class="paramname"> <em>val</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgreRadixSort_8h-source.html#l00174">174</a> of file <a class="el" href="OgreRadixSort_8h-source.html">OgreRadixSort.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="c54a7d0ddf8b1f42f4d33dc0b9aec0cd"></a><!-- doxytag: member="Ogre::RadixSort::getByte" ref="c54a7d0ddf8b1f42f4d33dc0b9aec0cd" args="(int byteIndex, TCompValueType val)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class TContainer, class TContainerValueType, typename TCompValueType&gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">unsigned char <a class="el" href="classOgre_1_1RadixSort.html">Ogre::RadixSort</a>&lt; TContainer, TContainerValueType, TCompValueType &gt;::getByte           </td>
          <td>(</td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>byteIndex</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">TCompValueType&nbsp;</td>
          <td class="paramname"> <em>val</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgreRadixSort_8h-source.html#l00220">220</a> of file <a class="el" href="OgreRadixSort_8h-source.html">OgreRadixSort.h</a>.</p>

<p>Referenced by <a class="el" href="OgreRadixSort_8h-source.html#l00141">Ogre::RadixSort&lt; std::vector&lt; RenderablePass &gt;, Ogre::RenderablePass, float &gt;::finalPass()</a>, <a class="el" href="OgreRadixSort_8h-source.html#l00240">Ogre::RadixSort&lt; std::vector&lt; RenderablePass &gt;, Ogre::RenderablePass, float &gt;::sort()</a>, and <a class="el" href="OgreRadixSort_8h-source.html#l00115">Ogre::RadixSort&lt; std::vector&lt; RenderablePass &gt;, Ogre::RenderablePass, float &gt;::sortPass()</a>.</p>

</div>
</div><p>
<a class="anchor" name="b3a589546b32250272870bd0cd471116"></a><!-- doxytag: member="Ogre::RadixSort::sort" ref="b3a589546b32250272870bd0cd471116" args="(TContainer &amp;container, TFunction func)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class TContainer, class TContainerValueType, typename TCompValueType&gt; </div>
<div class="memtemplate">
template&lt;class TFunction&gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1RadixSort.html">Ogre::RadixSort</a>&lt; TContainer, TContainerValueType, TCompValueType &gt;::sort           </td>
          <td>(</td>
          <td class="paramtype">TContainer &amp;&nbsp;</td>
          <td class="paramname"> <em>container</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">TFunction&nbsp;</td>
          <td class="paramname"> <em>func</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Main sort function. 
<p>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>container</em>&nbsp;</td><td>A container of the type you declared when declaring </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>func</em>&nbsp;</td><td>A functor which returns the value for comparison when given a container value </td></tr>
  </table>
</dl>

<p>Definition at line <a class="el" href="OgreRadixSort_8h-source.html#l00240">240</a> of file <a class="el" href="OgreRadixSort_8h-source.html">OgreRadixSort.h</a>.</p>

</div>
</div><p>
<hr><h2>Member Data Documentation</h2>
<a class="anchor" name="c6718da2036c0980c508536bbdf64668"></a><!-- doxytag: member="Ogre::RadixSort::mCounters" ref="c6718da2036c0980c508536bbdf64668" args="[4][256]" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class TContainer, class TContainerValueType, typename TCompValueType&gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">int <a class="el" href="classOgre_1_1RadixSort.html">Ogre::RadixSort</a>&lt; TContainer, TContainerValueType, TCompValueType &gt;::<a class="el" href="classOgre_1_1RadixSort.html#c6718da2036c0980c508536bbdf64668">mCounters</a>[4][256]<code> [protected]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Alpha-pass counters of values (histogram) 4 of them so we can radix sort a maximum of a 32bit value. 
<p>

<p>Definition at line <a class="el" href="OgreRadixSort_8h-source.html#l00090">90</a> of file <a class="el" href="OgreRadixSort_8h-source.html">OgreRadixSort.h</a>.</p>

<p>Referenced by <a class="el" href="OgreRadixSort_8h-source.html#l00141">Ogre::RadixSort&lt; std::vector&lt; RenderablePass &gt;, Ogre::RenderablePass, float &gt;::finalPass()</a>, <a class="el" href="OgreRadixSort_8h-source.html#l00240">Ogre::RadixSort&lt; std::vector&lt; RenderablePass &gt;, Ogre::RenderablePass, float &gt;::sort()</a>, and <a class="el" href="OgreRadixSort_8h-source.html#l00115">Ogre::RadixSort&lt; std::vector&lt; RenderablePass &gt;, Ogre::RenderablePass, float &gt;::sortPass()</a>.</p>

</div>
</div><p>
<a class="anchor" name="0d46f30b03aedeb510dec893bee18e64"></a><!-- doxytag: member="Ogre::RadixSort::mOffsets" ref="0d46f30b03aedeb510dec893bee18e64" args="[256]" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class TContainer, class TContainerValueType, typename TCompValueType&gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">int <a class="el" href="classOgre_1_1RadixSort.html">Ogre::RadixSort</a>&lt; TContainer, TContainerValueType, TCompValueType &gt;::<a class="el" href="classOgre_1_1RadixSort.html#0d46f30b03aedeb510dec893bee18e64">mOffsets</a>[256]<code> [protected]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Beta-pass offsets. 
<p>

<p>Definition at line <a class="el" href="OgreRadixSort_8h-source.html#l00092">92</a> of file <a class="el" href="OgreRadixSort_8h-source.html">OgreRadixSort.h</a>.</p>

<p>Referenced by <a class="el" href="OgreRadixSort_8h-source.html#l00141">Ogre::RadixSort&lt; std::vector&lt; RenderablePass &gt;, Ogre::RenderablePass, float &gt;::finalPass()</a>, and <a class="el" href="OgreRadixSort_8h-source.html#l00115">Ogre::RadixSort&lt; std::vector&lt; RenderablePass &gt;, Ogre::RenderablePass, float &gt;::sortPass()</a>.</p>

</div>
</div><p>
<a class="anchor" name="9c004d058dec49d422482103af7a06dd"></a><!-- doxytag: member="Ogre::RadixSort::mSortSize" ref="9c004d058dec49d422482103af7a06dd" args="" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class TContainer, class TContainerValueType, typename TCompValueType&gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">int <a class="el" href="classOgre_1_1RadixSort.html">Ogre::RadixSort</a>&lt; TContainer, TContainerValueType, TCompValueType &gt;::<a class="el" href="classOgre_1_1RadixSort.html#9c004d058dec49d422482103af7a06dd">mSortSize</a><code> [protected]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Sort area size. 
<p>

<p>Definition at line <a class="el" href="OgreRadixSort_8h-source.html#l00094">94</a> of file <a class="el" href="OgreRadixSort_8h-source.html">OgreRadixSort.h</a>.</p>

<p>Referenced by <a class="el" href="OgreRadixSort_8h-source.html#l00141">Ogre::RadixSort&lt; std::vector&lt; RenderablePass &gt;, Ogre::RenderablePass, float &gt;::finalPass()</a>, <a class="el" href="OgreRadixSort_8h-source.html#l00240">Ogre::RadixSort&lt; std::vector&lt; RenderablePass &gt;, Ogre::RenderablePass, float &gt;::sort()</a>, and <a class="el" href="OgreRadixSort_8h-source.html#l00115">Ogre::RadixSort&lt; std::vector&lt; RenderablePass &gt;, Ogre::RenderablePass, float &gt;::sortPass()</a>.</p>

</div>
</div><p>
<a class="anchor" name="02ac6146623e353cd5c36ffa4eb30373"></a><!-- doxytag: member="Ogre::RadixSort::mNumPasses" ref="02ac6146623e353cd5c36ffa4eb30373" args="" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class TContainer, class TContainerValueType, typename TCompValueType&gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">int <a class="el" href="classOgre_1_1RadixSort.html">Ogre::RadixSort</a>&lt; TContainer, TContainerValueType, TCompValueType &gt;::<a class="el" href="classOgre_1_1RadixSort.html#02ac6146623e353cd5c36ffa4eb30373">mNumPasses</a><code> [protected]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Number of passes for this type. 
<p>

<p>Definition at line <a class="el" href="OgreRadixSort_8h-source.html#l00096">96</a> of file <a class="el" href="OgreRadixSort_8h-source.html">OgreRadixSort.h</a>.</p>

<p>Referenced by <a class="el" href="OgreRadixSort_8h-source.html#l00220">Ogre::RadixSort&lt; std::vector&lt; RenderablePass &gt;, Ogre::RenderablePass, float &gt;::getByte()</a>, and <a class="el" href="OgreRadixSort_8h-source.html#l00240">Ogre::RadixSort&lt; std::vector&lt; RenderablePass &gt;, Ogre::RenderablePass, float &gt;::sort()</a>.</p>

</div>
</div><p>
<a class="anchor" name="2112b0f31c640327366def3806dcab5d"></a><!-- doxytag: member="Ogre::RadixSort::mSortArea1" ref="2112b0f31c640327366def3806dcab5d" args="" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class TContainer, class TContainerValueType, typename TCompValueType&gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">std::vector&lt;<a class="el" href="structOgre_1_1RadixSort_1_1SortEntry.html">SortEntry</a>&gt; <a class="el" href="classOgre_1_1RadixSort.html">Ogre::RadixSort</a>&lt; TContainer, TContainerValueType, TCompValueType &gt;::<a class="el" href="classOgre_1_1RadixSort.html#2112b0f31c640327366def3806dcab5d">mSortArea1</a><code> [protected]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Temp sort storage. 
<p>

<p>Definition at line <a class="el" href="OgreRadixSort_8h-source.html#l00108">108</a> of file <a class="el" href="OgreRadixSort_8h-source.html">OgreRadixSort.h</a>.</p>

<p>Referenced by <a class="el" href="OgreRadixSort_8h-source.html#l00240">Ogre::RadixSort&lt; std::vector&lt; RenderablePass &gt;, Ogre::RenderablePass, float &gt;::sort()</a>.</p>

</div>
</div><p>
<a class="anchor" name="d3a26ac464f5b59d75286e9b12cd2994"></a><!-- doxytag: member="Ogre::RadixSort::mSortArea2" ref="d3a26ac464f5b59d75286e9b12cd2994" args="" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class TContainer, class TContainerValueType, typename TCompValueType&gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">std::vector&lt;<a class="el" href="structOgre_1_1RadixSort_1_1SortEntry.html">SortEntry</a>&gt; <a class="el" href="classOgre_1_1RadixSort.html">Ogre::RadixSort</a>&lt; TContainer, TContainerValueType, TCompValueType &gt;::<a class="el" href="classOgre_1_1RadixSort.html#d3a26ac464f5b59d75286e9b12cd2994">mSortArea2</a><code> [protected]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgreRadixSort_8h-source.html#l00109">109</a> of file <a class="el" href="OgreRadixSort_8h-source.html">OgreRadixSort.h</a>.</p>

<p>Referenced by <a class="el" href="OgreRadixSort_8h-source.html#l00240">Ogre::RadixSort&lt; std::vector&lt; RenderablePass &gt;, Ogre::RenderablePass, float &gt;::sort()</a>.</p>

</div>
</div><p>
<a class="anchor" name="a22e981b5a53295efd161b192d636dcb"></a><!-- doxytag: member="Ogre::RadixSort::mSrc" ref="a22e981b5a53295efd161b192d636dcb" args="" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class TContainer, class TContainerValueType, typename TCompValueType&gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">std::vector&lt;<a class="el" href="structOgre_1_1RadixSort_1_1SortEntry.html">SortEntry</a>&gt;* <a class="el" href="classOgre_1_1RadixSort.html">Ogre::RadixSort</a>&lt; TContainer, TContainerValueType, TCompValueType &gt;::<a class="el" href="classOgre_1_1RadixSort.html#a22e981b5a53295efd161b192d636dcb">mSrc</a><code> [protected]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgreRadixSort_8h-source.html#l00110">110</a> of file <a class="el" href="OgreRadixSort_8h-source.html">OgreRadixSort.h</a>.</p>

<p>Referenced by <a class="el" href="OgreRadixSort_8h-source.html#l00141">Ogre::RadixSort&lt; std::vector&lt; RenderablePass &gt;, Ogre::RenderablePass, float &gt;::finalPass()</a>, <a class="el" href="OgreRadixSort_8h-source.html#l00240">Ogre::RadixSort&lt; std::vector&lt; RenderablePass &gt;, Ogre::RenderablePass, float &gt;::sort()</a>, and <a class="el" href="OgreRadixSort_8h-source.html#l00115">Ogre::RadixSort&lt; std::vector&lt; RenderablePass &gt;, Ogre::RenderablePass, float &gt;::sortPass()</a>.</p>

</div>
</div><p>
<a class="anchor" name="aeca7c2e0fe32e56d2e373b25d41a329"></a><!-- doxytag: member="Ogre::RadixSort::mDest" ref="aeca7c2e0fe32e56d2e373b25d41a329" args="" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class TContainer, class TContainerValueType, typename TCompValueType&gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">std::vector&lt;<a class="el" href="structOgre_1_1RadixSort_1_1SortEntry.html">SortEntry</a>&gt;* <a class="el" href="classOgre_1_1RadixSort.html">Ogre::RadixSort</a>&lt; TContainer, TContainerValueType, TCompValueType &gt;::<a class="el" href="classOgre_1_1RadixSort.html#aeca7c2e0fe32e56d2e373b25d41a329">mDest</a><code> [protected]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgreRadixSort_8h-source.html#l00111">111</a> of file <a class="el" href="OgreRadixSort_8h-source.html">OgreRadixSort.h</a>.</p>

<p>Referenced by <a class="el" href="OgreRadixSort_8h-source.html#l00240">Ogre::RadixSort&lt; std::vector&lt; RenderablePass &gt;, Ogre::RenderablePass, float &gt;::sort()</a>.</p>

</div>
</div><p>
<a class="anchor" name="98e68e712c66b7d02426d76382b4bff4"></a><!-- doxytag: member="Ogre::RadixSort::mTmpContainer" ref="98e68e712c66b7d02426d76382b4bff4" args="" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class TContainer, class TContainerValueType, typename TCompValueType&gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">TContainer <a class="el" href="classOgre_1_1RadixSort.html">Ogre::RadixSort</a>&lt; TContainer, TContainerValueType, TCompValueType &gt;::<a class="el" href="classOgre_1_1RadixSort.html#98e68e712c66b7d02426d76382b4bff4">mTmpContainer</a><code> [protected]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgreRadixSort_8h-source.html#l00112">112</a> of file <a class="el" href="OgreRadixSort_8h-source.html">OgreRadixSort.h</a>.</p>

<p>Referenced by <a class="el" href="OgreRadixSort_8h-source.html#l00240">Ogre::RadixSort&lt; std::vector&lt; RenderablePass &gt;, Ogre::RenderablePass, float &gt;::sort()</a>.</p>

</div>
</div><p>
<hr>The documentation for this class was generated from the following file:<ul>
<li><a class="el" href="OgreRadixSort_8h-source.html">OgreRadixSort.h</a></ul>
<hr>
<p>
Copyright &copy; 2000-2005 by The OGRE Team<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/"><img alt="Creative Commons License" border="0" src="http://creativecommons.org/images/public/somerights20.png"/></a><br/>
This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/">Creative Commons Attribution-ShareAlike 2.5 License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Mon Jun 16 12:51:58 2008
</p>
</body>
</html>
